var hidden = false;
var date = new Date();
var updateDateTimer = null;
var currentMonth = null;
var currentYear = null;
var currentDate = null;
var connectionError = false;
var fontSize = 11;

/** UPDATE DATE STUFF (borrowed from apple calendar) **/
function setupUpdateTimer ()
{
	if (updateDateTimer != null)
	{
		clearTimeout (updateDateTimer);
		updateDateTimer = null;
	}
		
	// create a new timer for when we need to update the date
	var hourMillis = ((23 - date.getHours()) * 3600000);
	var minsMillis = ((59 - date.getMinutes()) * 60000);
	var secsMillis = ((60 - date.getSeconds()) * 1000); // overshoot a second
	var millisRemaining = hourMillis + minsMillis + secsMillis;
	
	if (connectionError)
	   updateDateTimer = setTimeout("updateDate();", 10000);
	else
	   updateDateTimer = setTimeout("updateDate();", millisRemaining);
}


function updateDate() {
    if (!hidden) {
        date = new Date();
        var currentEqualDate = date.getMonth() == currentMonth &&
                              date.getFullYear() == currentYear &&
                              date.getDate() == currentDate;
        if (!currentEqualDate)
        {
            // only change the current vars if don't match
            // the new date
            currentMonth = date.getMonth();
            currentYear = date.getFullYear();
            currentDate = date.getDate();
            getContent();
        }
        else if (connectionError)
           getContent();   
        
        // reset the timer
        setupUpdateTimer();
    }
}

function onshow () {
	// refresh the date, in case it's changed
	updateDate();
}

function onhide () {
	if (updateDateTimer) {
		clearTimeout(updateDateTimer);
		updateDateTimer = null;
	}
}

function setup()
{
    if(window.widget)
    {
        fontSizeString = widget.preferenceForKey("fontSize");
        if (fontSizeString && fontSizeString.length > 0)
        {
            fontSize = parseInt(fontSizeString);
            document.getElementById('mainContent').style.fontSize=fontSizeString;
        }
        else fontSizeString = '11px';
    }
    scrollerInit(document.getElementById("myScrollBar"), document.getElementById("myScrollTrack"), document.getElementById("myScrollThumb"));
    createGenericButton(document.getElementById('done'), 'Done', hidePrefs);
    createGenericButton(document.getElementById('tryagain'), 'Try Again', updateDate);
    //toggleDebug();
    if (window.widget)
    {
        widget.onshow = onshow;
        widget.onhide = onhide;
    }
    updateDate();
    return 0;
}

function getContent() {
    connectionError = false;
    document.getElementById("error").style.display = "none";
    document.getElementById("date").innerHTML = "Connecting to DailyTao.org...";
    document.getElementById("mainContent").innerHTML = "";
    calculateAndShowThumb(document.getElementById('mainContent'));
    // account for weird hour bug in formatDate.js
    // otherwise, only changes day after 1am
    date.setHours(date.getHours()+1);
    index = (date.formatDate("z")-69)%80;
    date.setHours(date.getHours()+-1);
    if (index < 0) 
        index += 81;
    title = date.formatDate("l, j F, Y")+" :: "+(index+1);
    
    DEBUG("request: " + "http://dailytao.org/dailytao-org-wdgt-1.1.php?index="+index);
    
    xmlhttp = new XMLHttpRequest();
    xmlhttp.open("GET", "http://dailytao.org/dailytao-org-wdgt-1.1.php?index="+index, false);
    xmlhttp.send(null);
    
    DEBUG("response: " + xmlhttp.responseText);
    
    content = xmlhttp.responseText;
    if (content == null) {
          
        document.getElementById("date").innerHTML = "Connection Error";
        document.getElementById("error").style.display = "block";
        connectionError = true;
    }
    else {
        content = xmlhttp.responseText;
        document.getElementById("date").innerHTML = title;
        document.getElementById("mainContent").innerHTML = content;
        calculateAndShowThumb(document.getElementById('mainContent'));
    }
    scrollContent(-1)
}

/* menu */

function showMenu()
{
    exitflip(event,"actionrollie");
    
    document.getElementById("actionmenu").style.display="block";
        
    if (animation2.timer != null)			// reset the animation timer value, in case a value was left behind
    {
        clearInterval (animation2.timer);
        animation2.timer  = null;
    }
    
    var starttime = (new Date).getTime() - 13; 		// set it back one frame
    
    animation2.duration = 200;												// animation2 time, in ms
    animation2.starttime = starttime;										// specify the start time
    animation2.firstElement = document.getElementById ('actionmenu');		// specify the element to fade
    animation2.timer = setInterval ("animate(animation2);", 13);						// set the animation2 function
    animation2.from = animation2.now;											// beginning opacity (not ness. 0)
    animation2.to = 1.0;														// final opacity
    animate(animation2);
    
    document.addEventListener("mousedown", hideMenu, true);
}

function hideMenu()
{
    exitflip(event,"actionrollie");
    
     if (animation2.timer != null)			// reset the animation timer value, in case a value was left behind
    {
        clearInterval (animation2.timer);
        animation2.timer  = null;
    }
    
    var starttime = (new Date).getTime() - 13; 		// set it back one frame
    
    animation2.duration = 500;												// animation2 time, in ms
    animation2.starttime = starttime;										// specify the start time
    animation2.firstElement = document.getElementById ('actionmenu');		// specify the element to fade
    animation2.timer = setInterval ("animate(animation2);", 13);						// set the animation2 function
    animation2.from = 1.0;											// beginning opacity (not ness. 0)
    animation2.to = 0.0;														// final opacity
    animate(animation2);
    document.removeEventListener("mousedown", hideMenu, true);
    
    setTimeout('document.getElementById("actionmenu").style.display="none"',210);
}

function setFontSize(delta)
{
    fontSize += delta;
    fontSizeString = fontSize.toString()+"px";
    if(window.widget)
    {
        widget.setPreferenceForKey(fontSizeString,"fontSize");
    }
    else alert(fontSizeString);
    document.getElementById('mainContent').style.fontSize=fontSize;
    calculateAndShowThumb(document.getElementById('mainContent'));
    return 0;
}

function copyChapter()
{
    widget.system('/bin/echo -n "' + 
        ['DailyTao.org\n' + document.getElementById('date').innerText + '\n\n' 
         + document.getElementById('mainContent').innerText
         + '\n\nTranslation by Stephen Mitchel.\nDailyTao.org Widget by Glen Sanford.'] 
        + '" | /usr/bin/pbcopy', null);
    return 0;
}

/*********************************/
// HIDING AND SHOWING PREFERENCES
/*********************************/

// showPrefs() is called when the preferences flipper is clicked upon.  It freezes the front of the widget,
// hides the front div, unhides the back div, and then flips the widget over.

function showPrefs()
{
    hidden = true;
    
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToBack");		// freezes the widget so that you can change it without the user noticing
	
	front.style.display="none";		// hide the front
	back.style.display="block";		// show the back
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget over	

	document.getElementById('fliprollie').style.display = 'none';  // clean up the front side - hide the circle behind the info button

}


// hidePrefs() is called by the done button on the back side of the widget.  It performs the opposite transition
// as showPrefs() does.

function hidePrefs()
{
	var front = document.getElementById("front");
	var back = document.getElementById("back");
	
	if (window.widget)
		widget.prepareForTransition("ToFront");		// freezes the widget and prepares it for the flip back to the front
	
	back.style.display="none";			// hide the back
	front.style.display="block";		// show the front
	
	if (window.widget)
		setTimeout ('widget.performTransition();', 0);		// and flip the widget back to the front
		
    hidden = false;
    updatetimeout = setTimeout ('updateDate();', 0);	
}


// PREFERENCE BUTTON ANIMATION (- the pref flipper fade in/out)

var flipShown = false;		// a flag used to signify if the flipper is currently shown or not.


// A structure that holds information that is needed for the animation to run.
var animation1 = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};
var animation2 = {duration:0, starttime:0, to:1.0, now:0.0, from:0.0, firstElement:null, timer:null};

// mousemove() is the event handle assigned to the onmousemove property on the front div of the widget. 
// It is triggered whenever a mouse is moved within the bounds of your widget.  It prepares the
// preference flipper fade and then calls animate() to performs the animation.

function mousemove (event)
{
	if (!flipShown)			// if the preferences flipper is not already showing...
	{
		if (animation1.timer != null)			// reset the animation1 timer value, in case a value was left behind
		{
			clearInterval (animation1.timer);
			animation1.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13; 		// set it back one frame
		
		animation1.duration = 500;												// animation1 time, in ms
		animation1.starttime = starttime;										// specify the start time
		animation1.firstElement = document.getElementById ('buttons');		// specify the element to fade
		animation1.timer = setInterval ("animate(animation1);", 13);						// set the animation1 function
		animation1.from = animation1.now;											// beginning opacity (not ness. 0)
		animation1.to = 1.0;														// final opacity
		animate(animation1);
		
		
		
		// begin animation
		flipShown = true;														// mark the flipper as animated
	}
}

// mouseexit() is the opposite of mousemove() in that it preps the preferences flipper
// to disappear.  It adds the appropriate values to the animation data structure and sets the animation in motion.

function mouseexit (event)
{
	if (flipShown)
	{
		// fade in the flip widget
		if (animation1.timer != null)
		{
			clearInterval (animation1.timer);
			animation1.timer  = null;
		}
		
		var starttime = (new Date).getTime() - 13;
		
		animation1.duration = 500;
		animation1.starttime = starttime;
		animation1.firstElement = document.getElementById ('buttons');
		animation1.timer = setInterval ("animate(animation1);", 13);
		animation1.from = animation1.now;
		animation1.to = 0.0;
		animate(animation1);
		flipShown = false;
	}
}


// animate() performs the fade animation for the preferences flipper. It uses the opacity CSS property to simulate a fade.

function animate(animation)
{
	var T;
	var ease;
	var time = (new Date).getTime();
		
	
	T = limit_3(time-animation.starttime, 0, animation.duration);
	
	if (T >= animation.duration)
	{
		clearInterval (animation.timer);
		animation.timer = null;
		animation.now = animation.to;
	}
	else
	{
		ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
		animation.now = computeNextFloat (animation.from, animation.to, ease);
	}
	
	animation.firstElement.style.opacity = animation.now;
}


// these functions are utilities used by animate()

function limit_3 (a, b, c)
{
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat (from, to, ease)
{
    return from + (to - from) * ease;
}

// these functions are called when the info button itself receives onmouseover and onmouseout events

function enterflip(event,id)
{
	document.getElementById(id).style.display = 'block';
}

function exitflip(event,id)
{
	document.getElementById(id).style.display = 'none';
}